<!DOCTYPE html>
<html lang="en">
    <meta charset="utf-8" />
    <title>Journal Entries</title>
    <head>
        <link rel="stylesheet" href="https://code.getmdl.io/1.3.0/material.blue_grey-blue.min.css"/> 
        <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
        <link rel="stylesheet" href="style.css">
        <script src="https://code.getmdl.io/1.3.0/material.min.js"></script>
        <link rel="shortcut icon" type="image/png" href="/favicon.png"/>
    </head>
    <body>
        <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
            <header class="mdl-layout__header">
              <div class="mdl-layout__header-row">
                <span class="mdl-layout-title">IB Personal Project</span>
              </div>
              <div class="mdl-layout__tab-bar mdl-js-ripple-effect mdl-layout--large-screen-only">
                <a href="index.html" class="mdl-layout__tab">Home</a>
                <a href="prices.html" class="mdl-layout__tab">Housing Prices</a>
                <a href="digits.html" class="mdl-layout__tab">Handwritten Digits</a>
                <a href="reviews.html" class="mdl-layout__tab">Movie Reviews</a>
                <a href="entries.html" class="mdl-layout__tab is-active">Journal Entries</a>
              </div>
            </header>
            <div class="mdl-layout__drawer mdl-layout--small-screen-only">
              <span class="mdl-layout__title">IB Personal Project</span>
              <nav class="mdl-navigation">
                <a class="mdl-navigation__link" href="index.html">Home</a>
                <a class="mdl-navigation__link" href="prices.html">Housing Prices</a>
                <a class="mdl-navigation__link" href="digits.html">Handwritten Digits</a>
                <a class="mdl-navigation__link" href="reviews.html">Movie Reviews</a>
                <a class="mdl-navigation__link" href="entries.html">Journal Entries</a>
              </nav>
            </div>
            <main class="mdl-layout__content">
                <div class="page-content">
                  
                  <div class="mdl-grid">
                    <div class="scrollmenu">
                      <button onclick="location.href='#2019-06-10';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-06-10
                      </button>
                      <button onclick="location.href='#2019-07-17';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-07-17
                      </button>
                      <button onclick="location.href='#2019-08-28';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-08-27
                      </button>
                      <button onclick="location.href='#2019-09-09';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-09-09
                      </button>
                      <button onclick="location.href='#2019-09-21';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-09-21
                      </button>
                      <button onclick="location.href='#2019-09-28';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-09-28
                      </button>
                      <button onclick="location.href='#2019-10-05';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-10-05
                      </button>
                      <button onclick="location.href='#2019-10-12';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-10-12
                      </button>
                      <button onclick="location.href='#2019-10-26';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-10-26
                      </button>
                      <button onclick="location.href='#2019-11-02';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-11-02
                      </button>
                      <button onclick="location.href='#2019-11-09';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-11-09
                      </button>
                      <button onclick="location.href='#2019-11-16';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-11-16
                      </button>
                      <button onclick="location.href='#2019-11-23';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-11-23
                      </button>
                      <button onclick="location.href='#2019-11-30';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-11-30
                      </button>
                      <button onclick="location.href='#2019-12-07';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-12-07
                      </button>
                      <button onclick="location.href='#2019-12-14';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-12-14
                      </button>
                      <button onclick="location.href='#2019-12-21';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-12-21
                      </button>
                      <button onclick="location.href='#2019-12-28';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2019-12-28
                      </button>
                      <button onclick="location.href='#2019-01-04';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2020-01-04
                      </button>
                      <button onclick="location.href='#2019-01-11';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2020-01-11
                      </button>
                      <button onclick="location.href='#2019-01-18';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2020-01-18
                      </button>
                      <button onclick="location.href='#2019-01-25';" class="mdl-button mdl-js-button mdl-js-ripple-effect button-accent">
                        2020-01-25
                      </button>

                    </div>
                  </div>
                </div>
                <section class="mdl-layout__tab-panel is-active" id="2019-06-10">
                  <div class="page-content centre"> 
                    <h1>2019-06-10</h1>
                    <hr>
                    <p>There are two main areas in which I would like to do my personal project.</p>
                    <p>&nbsp;</p>
                    <h3>Climate Change:</h3>
                    <ul>
                    <li>Help build the website for a local Charlotte campaign</li>
                    <li>Help talk to local city councils about climate action</li>
                    <li>Help build a place for people to donate to climate campaigns or attend events world wide</li>

                    </ul>
                    <h3>Computer Programming</h3>
                    <ul>
                    <li>Build a neural network for replication</li>
                    <li>Build a neural network for handwritten characters</li>
                    <li>Build a recursive or evolutionary neural network</li>
                    <li>Build an organization suite</li>
                    <li>Build a docker cluster</li>
                    <li>Build a whole host of machine learning models</li>
                    <li>Contribute to an open source project.</li>

                    </ul>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-07-17">
                  <div class="page-content centre"> 
                    <h1>2019-07-17</h1> <hr>
                    <p>My current two leading ideas are ideas which are truly &quot;personal&quot; projects, really cool technological creations I&#39;ve always wanted to create. Programming also allows me to fulfill the global requirement of the personal project because programming is an inherently global and innovative discipline.</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-08-27">
                  <div class="page-content centre"> 
                    <h1>2019-08-27</h1> <hr>
                    <ul>
                    <li>My main goal is to learn new programming skills in a variety of areas.</li>
                    <li>A successful project will have me learning new applicable skills</li>
                    <li>My biggest challenge will just be the amount of knowledge I will need to even create a compelling project which can really be solved through scheduling.</li>

                    </ul>
                    <p>I have decided on my project, it will be &quot;Build a variety of machine learning programs&quot;. This project falls into Scientific and Technological Innovation as machine learning is at the forefront of modern research due to massive amount of data that needs to be analyzed.                             </p>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-09-09">
                  <div class="page-content centre"> 
                    <h1>2019-09-09</h1><hr>
                    <h2>Project Description</h2>
                    <p>Who? Me, obviously.</p>
                    <p>What? I intend to create a myriad of machine learning algorithms that will effectively demonstrate my learning.</p>
                    <p>When? I have begun planning, and next week is when I start with about 1hrs dedicated per week to the project.</p>
                    <p>Where? Along with the required poster at the end of the project, I am creating a website to go along with it to sufficiently demonstrate all of the work that I have done.</p>
                    <p>Why? I have always wanted to do more work relating to machine learning and this is the perfect time to start.</p>
                    <h2>Global Context</h2>
                    <p>The global context for my project is <strong>Scientific &amp; Technological Innovation</strong>. My project falls squarely into this category because I am going to be using systems and models, to find novel solutions to machine learning problems. Machine learning is also inherently a art of adaptation , ingenuity and progress. Machine learning also is integral to modernization as it becomes embedded in our species. It even relates to the biological revolution as <a href='https://www.npr.org/2019/08/09/749938354/episode-932-deep-learning-with-the-elephants'>scientists</a> are using this technology to save endangered species. Machine learning is also functionally just a complex linear algebra problem so it relates to the last criterion of mathematical, puzzles, principles, and discovery.</p>
                    <h2>S.M.A.R.T Goal</h2>

                    <table class="mdl-data-table mdl-js-data-table mdl-shadow--2dp my-table">
                      <thead>
                        <tr>
                          <th>Acronym</th>
                          <th>Explanation</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr>
                          <td>Specific</td>
                          <td>My goal is to have an exploration into machine learning. My plan is to complete the "Machine Learning Mastery" course along the way.</td>
                        </tr>
                        <tr>
                          <td>Measurable</td>
                          <td>The measure of the goal will be in the algorithms I will be able to publish at the end of the process on my website.</td>
                        </tr>
                        <tr>

                          <td>Assignable</td>
                          <td>Primarily it will be my journey through the "Machine Learning Mastery Course" that guide my project. Additionally, I will be attending the local "Machine Learning Meet-up"</td>
                        </tr>
                        <tr>
 
                          <td>Realistic</td>
                          <td>I have all of the material ready to begin the course, and I already know how to program in the language that I need to know for the project so I will be able to complete it.</td>
                        </tr>
                        <tr>
 
                          <td>Time-Based</td>
                          <td>My plan is possible as long I stick to my schedule as it gives me plenty of time after finishing the course to get my website together.</td>
                        </tr>
                      </tbody>
                    </table>

                    <h2>Prior Learning</h2>
                    <ul>
                    <li>I know how to program in Python 3, the language needed for machine learning</li>
                    <li>I have already gone through the &quot;Machine Learning and Deep Learning without a Ph.D&quot; lecture.</li>

                    </ul>
                    <h2>Calendar</h2>
                    <ul>
                    <li>45 mins on Wednesday and Friday</li>
                    <li>This has me through the entire course in 5 weeks</li>

                    </ul>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-09-21">
                  <div class="page-content centre"> 
                    <h1>2019-09-21</h1><hr>
                    <p>To start my journey with machine learning I have to do a basic introduction. So, I started the Machine Learning Crash Course. Today I worked on 2 parts of the course. Introduction to machine learning which explains why we use machine learning and why it is important and machine learning problem framing which explains the words which we use to describe machine learning. Tomorrow 2019-09-22 I have a meeting with an outside advisor. </p>
                    <h2>Introduction</h2>
                    <p>Here are the main points that I came away with. Much of this I already know as a virtue of me being extremely interesting in computers and mathematics already. This also fills the prerequisites of mathematical knowledge and programming experience for the Crash Course.</p>
                    <p><strong>Four Reasons Why Machine Learning is Great</strong></p>
                    <ol start='' >
                    <li>It reduces the time you spend programming
                    <p>For example if you want to write a program for spelling error, you would have to write a complex algorithm to find common misspellings and complex rules. However, with machine learning you can just give your program a dataset.</p>
                    </li>
                    <li>Customization of tools
                    <p>If your program became so popular that people who want to speak other languages wanted to use it, how would you go about doing that. With machine learning with a data set and some basic approximation you can customize.</p>
                    </li>
                    <li>Solving impossible programs
                    <p>If you were asked to write a program to differentiate bees and threes it would be nearly impossible as your recognition is powered by extremely complex subconscious processes, however with machine learning it as a simple as a dataset.</p>
                    </li>
                    <li>It changes how you think
                    <p>It trains you to start thinking in a more experimental way than in a strictly ordered way, you begin thinking about statistics, logic, analyzing results which opens up areas you couldn&#39;t have without it.</p>
                    </li>

                    </ol>
                    <h2>Framing</h2>
                    <p>This part begins to introduce how supervised learning works by looking at how machine learning systems learn, how they combine input, how to produce useful prediction, how to replicate those predictions on novel data. First, you have to know the terminology so I have listed it below.</p>
                    <p><strong>Label</strong>: What you are predicting (spam, not spam) and is usually represented by the variable <em>y</em></p>
                    <p><strong>Features</strong>: The input variables that describe the data (words in the email) usually represented by variables <em>{x<sub>1</sub>, x<sub>2</sub> ..., x<sub>n</sub>}</em></p>
                    <p><strong>Examples</strong></p>
                    <ul>
                    <li><strong>Example</strong>: A instance of data <em>x</em></li>
                    <li><strong>Labeled examples</strong>: have features and a label, used to train the model</li>
                    <li><strong>Unlabeled examples</strong>: has only features, used to make prediction on new data.</li>

                    </ul>
                    <p><strong>Model</strong>: The thing that makes prediction, maps examples to labels.</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-09-28">
                  <div class="page-content centre"> 
                    <h1>2019-09-22</h1><hr>
                    <p>Today was my meeting with my outside advisor. Rob Mulhstein who I have known for some time know through the coding school that he runs. We went through language choice</p>
                    <h2>Language Choice</h2>
                    <p>Since I&#39;m using tensorflow which is Google&#39;s machine learning library for this project I have the choice between 3 languages which my mentor and I talked through.</p>
                    <table class="mdl-data-table mdl-js-data-table mdl-shadow--2dp my-table">
                      <thead>
                        <tr>
                          <th>Python</th>
                          <th>JavaScript</th>
                          <th>Go/ Golang</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr>
                          <td>Pro: Already used for the majority of machine learning and thus has many resources.</td>
                          <td>Pro: This is really the future in terms of mobile machine learning</td>
                          <td>Pro: I am the best at Go</td>
                        </tr>
                        <tr>
                          <td>Con: Python's weirdness (only 3.6 and terrible asynchronous performance)</td>
                          <td>Con: Not very powerful because it is limited to web and mobile</td>
                          <td>Con: Not widely used for machine learning; very few resources</td>
                        </tr>
                      </tbody>
                    </table>

                    <h2>Prior Learning</h2>
                    <ul>
                    <li>I know how to program in Python 3, the language needed for machine learning</li>
                    <li>I have already gone through the &quot;Machine Learning and Deep Learning without a Ph.D&quot; lecture.</li>

                    </ul>
                    <h2>Calendar</h2>
                    <ul>
                    <li>45 mins on Wednesday and Friday</li>
                    <li>This has me through the entire course in 5 weeks</li>
                    <p>I chose python simply for its support</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-10-05">
                  <div class="page-content centre"> 
                    <h1>Journal Entry 2019-10-05</h1><hr>
                    <h2>Linear Regression Video</h2>

                    <ul>
                    <li>A model is something you learn (yes, learn is used as a gerund in the machine learning field) from data
                    </li>
                    <li>You can use simple linear regression to predict output
                    </li>
                    <li>use y=w<sub>1</sub>x<sub>1</sub>+b
                    <ul>
                    <li>W is the weighting vectors so it gives use our slope</li>
                    <li>Subscript represents the different dimension</li>
                    <li>The B is the bias</li>

                    </ul>
                  </li>
                    <li>Loss how good a line at fitting to the values - the same as residuals in statistics
                    </li>
                    <li>Loss function for regression
                    <ul>
                    <li>L<sub>2</sub> is the squared error that is the difference between the prediction and label</li>

                    </ul>
                    </li>
                    <li>Defining L<sub>2</sub> on a data set
                    <ul>
                    <li><div contenteditable="false" spellcheck="false" class="mathjax-block md-end-block md-math-block md-rawblock" id="mathjax-n28" cid="n28" mdtype="math_block"><div class="md-rawblock-container md-math-container" tabindex="-1"><div class="MathJax_SVG_Display" style="text-align: center;"><span class="MathJax_SVG" id="MathJax-Element-1-Frame" tabindex="-1" style="font-size: 100%; display: inline-block;"><svg xmlns:xlink="http://www.w3.org/1999/xlink" width="37.033ex" height="5.846ex" viewBox="0 -1007.2 15944.8 2517" role="img" focusable="false" style="vertical-align: -3.507ex; max-width: 100%;"><defs><path stroke-width="0" id="E1-MJMATHI-4C" d="M228 637Q194 637 192 641Q191 643 191 649Q191 673 202 682Q204 683 217 683Q271 680 344 680Q485 680 506 683H518Q524 677 524 674T522 656Q517 641 513 637H475Q406 636 394 628Q387 624 380 600T313 336Q297 271 279 198T252 88L243 52Q243 48 252 48T311 46H328Q360 46 379 47T428 54T478 72T522 106T564 161Q580 191 594 228T611 270Q616 273 628 273H641Q647 264 647 262T627 203T583 83T557 9Q555 4 553 3T537 0T494 -1Q483 -1 418 -1T294 0H116Q32 0 32 10Q32 17 34 24Q39 43 44 45Q48 46 59 46H65Q92 46 125 49Q139 52 144 61Q147 65 216 339T285 628Q285 635 228 637Z"></path><path stroke-width="0" id="E1-MJMAIN-32" d="M109 429Q82 429 66 447T50 491Q50 562 103 614T235 666Q326 666 387 610T449 465Q449 422 429 383T381 315T301 241Q265 210 201 149L142 93L218 92Q375 92 385 97Q392 99 409 186V189H449V186Q448 183 436 95T421 3V0H50V19V31Q50 38 56 46T86 81Q115 113 136 137Q145 147 170 174T204 211T233 244T261 278T284 308T305 340T320 369T333 401T340 431T343 464Q343 527 309 573T212 619Q179 619 154 602T119 569T109 550Q109 549 114 549Q132 549 151 535T170 489Q170 464 154 447T109 429Z"></path><path stroke-width="0" id="E1-MJMATHI-6F" d="M201 -11Q126 -11 80 38T34 156Q34 221 64 279T146 380Q222 441 301 441Q333 441 341 440Q354 437 367 433T402 417T438 387T464 338T476 268Q476 161 390 75T201 -11ZM121 120Q121 70 147 48T206 26Q250 26 289 58T351 142Q360 163 374 216T388 308Q388 352 370 375Q346 405 306 405Q243 405 195 347Q158 303 140 230T121 120Z"></path><path stroke-width="0" id="E1-MJMATHI-73" d="M131 289Q131 321 147 354T203 415T300 442Q362 442 390 415T419 355Q419 323 402 308T364 292Q351 292 340 300T328 326Q328 342 337 354T354 372T367 378Q368 378 368 379Q368 382 361 388T336 399T297 405Q249 405 227 379T204 326Q204 301 223 291T278 274T330 259Q396 230 396 163Q396 135 385 107T352 51T289 7T195 -10Q118 -10 86 19T53 87Q53 126 74 143T118 160Q133 160 146 151T160 120Q160 94 142 76T111 58Q109 57 108 57T107 55Q108 52 115 47T146 34T201 27Q237 27 263 38T301 66T318 97T323 122Q323 150 302 164T254 181T195 196T148 231Q131 256 131 289Z"></path><path stroke-width="0" id="E1-MJMAIN-3D" d="M56 347Q56 360 70 367H707Q722 359 722 347Q722 336 708 328L390 327H72Q56 332 56 347ZM56 153Q56 168 72 173H708Q722 163 722 153Q722 140 707 133H70Q56 140 56 153Z"></path><path stroke-width="0" id="E1-MJSZ2-2211" d="M60 948Q63 950 665 950H1267L1325 815Q1384 677 1388 669H1348L1341 683Q1320 724 1285 761Q1235 809 1174 838T1033 881T882 898T699 902H574H543H251L259 891Q722 258 724 252Q725 250 724 246Q721 243 460 -56L196 -356Q196 -357 407 -357Q459 -357 548 -357T676 -358Q812 -358 896 -353T1063 -332T1204 -283T1307 -196Q1328 -170 1348 -124H1388Q1388 -125 1381 -145T1356 -210T1325 -294L1267 -449L666 -450Q64 -450 61 -448Q55 -446 55 -439Q55 -437 57 -433L590 177Q590 178 557 222T452 366T322 544L56 909L55 924Q55 945 60 948Z"></path><path stroke-width="0" id="E1-MJMAIN-28" d="M94 250Q94 319 104 381T127 488T164 576T202 643T244 695T277 729T302 750H315H319Q333 750 333 741Q333 738 316 720T275 667T226 581T184 443T167 250T184 58T225 -81T274 -167T316 -220T333 -241Q333 -250 318 -250H315H302L274 -226Q180 -141 137 -14T94 250Z"></path><path stroke-width="0" id="E1-MJMATHI-78" d="M52 289Q59 331 106 386T222 442Q257 442 286 424T329 379Q371 442 430 442Q467 442 494 420T522 361Q522 332 508 314T481 292T458 288Q439 288 427 299T415 328Q415 374 465 391Q454 404 425 404Q412 404 406 402Q368 386 350 336Q290 115 290 78Q290 50 306 38T341 26Q378 26 414 59T463 140Q466 150 469 151T485 153H489Q504 153 504 145Q504 144 502 134Q486 77 440 33T333 -11Q263 -11 227 52Q186 -10 133 -10H127Q78 -10 57 16T35 71Q35 103 54 123T99 143Q142 143 142 101Q142 81 130 66T107 46T94 41L91 40Q91 39 97 36T113 29T132 26Q168 26 194 71Q203 87 217 139T245 247T261 313Q266 340 266 352Q266 380 251 392T217 404Q177 404 142 372T93 290Q91 281 88 280T72 278H58Q52 284 52 289Z"></path><path stroke-width="0" id="E1-MJMAIN-2C" d="M78 35T78 60T94 103T137 121Q165 121 187 96T210 8Q210 -27 201 -60T180 -117T154 -158T130 -185T117 -194Q113 -194 104 -185T95 -172Q95 -168 106 -156T131 -126T157 -76T173 -3V9L172 8Q170 7 167 6T161 3T152 1T140 0Q113 0 96 17Z"></path><path stroke-width="0" id="E1-MJMATHI-79" d="M21 287Q21 301 36 335T84 406T158 442Q199 442 224 419T250 355Q248 336 247 334Q247 331 231 288T198 191T182 105Q182 62 196 45T238 27Q261 27 281 38T312 61T339 94Q339 95 344 114T358 173T377 247Q415 397 419 404Q432 431 462 431Q475 431 483 424T494 412T496 403Q496 390 447 193T391 -23Q363 -106 294 -155T156 -205Q111 -205 77 -183T43 -117Q43 -95 50 -80T69 -58T89 -48T106 -45Q150 -45 150 -87Q150 -107 138 -122T115 -142T102 -147L99 -148Q101 -153 118 -160T152 -167H160Q177 -167 186 -165Q219 -156 247 -127T290 -65T313 -9T321 21L315 17Q309 13 296 6T270 -6Q250 -11 231 -11Q185 -11 150 11T104 82Q103 89 103 113Q103 170 138 262T173 379Q173 380 173 381Q173 390 173 393T169 400T158 404H154Q131 404 112 385T82 344T65 302T57 280Q55 278 41 278H27Q21 284 21 287Z"></path><path stroke-width="0" id="E1-MJMAIN-29" d="M60 749L64 750Q69 750 74 750H86L114 726Q208 641 251 514T294 250Q294 182 284 119T261 12T224 -76T186 -143T145 -194T113 -227T90 -246Q87 -249 86 -250H74Q66 -250 63 -250T58 -247T55 -238Q56 -237 66 -225Q221 -64 221 250T66 725Q56 737 55 738Q55 746 60 749Z"></path><path stroke-width="0" id="E1-MJMAIN-2208" d="M84 250Q84 372 166 450T360 539Q361 539 377 539T419 540T469 540H568Q583 532 583 520Q583 511 570 501L466 500Q355 499 329 494Q280 482 242 458T183 409T147 354T129 306T124 272V270H568Q583 262 583 250T568 230H124V228Q124 207 134 177T167 112T231 48T328 7Q355 1 466 0H570Q583 -10 583 -20Q583 -32 568 -40H471Q464 -40 446 -40T417 -41Q262 -41 172 45Q84 127 84 250Z"></path><path stroke-width="0" id="E1-MJMATHI-44" d="M287 628Q287 635 230 637Q207 637 200 638T193 647Q193 655 197 667T204 682Q206 683 403 683Q570 682 590 682T630 676Q702 659 752 597T803 431Q803 275 696 151T444 3L430 1L236 0H125H72Q48 0 41 2T33 11Q33 13 36 25Q40 41 44 43T67 46Q94 46 127 49Q141 52 146 61Q149 65 218 339T287 628ZM703 469Q703 507 692 537T666 584T629 613T590 629T555 636Q553 636 541 636T512 636T479 637H436Q392 637 386 627Q384 623 313 339T242 52Q242 48 253 48T330 47Q335 47 349 47T373 46Q499 46 581 128Q617 164 640 212T683 339T703 469Z"></path><path stroke-width="0" id="E1-MJMAIN-2212" d="M84 237T84 250T98 270H679Q694 262 694 250T679 230H98Q84 237 84 250Z"></path><path stroke-width="0" id="E1-MJMATHI-70" d="M23 287Q24 290 25 295T30 317T40 348T55 381T75 411T101 433T134 442Q209 442 230 378L240 387Q302 442 358 442Q423 442 460 395T497 281Q497 173 421 82T249 -10Q227 -10 210 -4Q199 1 187 11T168 28L161 36Q160 35 139 -51T118 -138Q118 -144 126 -145T163 -148H188Q194 -155 194 -157T191 -175Q188 -187 185 -190T172 -194Q170 -194 161 -194T127 -193T65 -192Q-5 -192 -24 -194H-32Q-39 -187 -39 -183Q-37 -156 -26 -148H-6Q28 -147 33 -136Q36 -130 94 103T155 350Q156 355 156 364Q156 405 131 405Q109 405 94 377T71 316T59 280Q57 278 43 278H29Q23 284 23 287ZM178 102Q200 26 252 26Q282 26 310 49T356 107Q374 141 392 215T411 325V331Q411 405 350 405Q339 405 328 402T306 393T286 380T269 365T254 350T243 336T235 326L232 322Q232 321 229 308T218 264T204 212Q178 106 178 102Z"></path><path stroke-width="0" id="E1-MJMATHI-72" d="M21 287Q22 290 23 295T28 317T38 348T53 381T73 411T99 433T132 442Q161 442 183 430T214 408T225 388Q227 382 228 382T236 389Q284 441 347 441H350Q398 441 422 400Q430 381 430 363Q430 333 417 315T391 292T366 288Q346 288 334 299T322 328Q322 376 378 392Q356 405 342 405Q286 405 239 331Q229 315 224 298T190 165Q156 25 151 16Q138 -11 108 -11Q95 -11 87 -5T76 7T74 17Q74 30 114 189T154 366Q154 405 128 405Q107 405 92 377T68 316T57 280Q55 278 41 278H27Q21 284 21 287Z"></path><path stroke-width="0" id="E1-MJMATHI-65" d="M39 168Q39 225 58 272T107 350T174 402T244 433T307 442H310Q355 442 388 420T421 355Q421 265 310 237Q261 224 176 223Q139 223 138 221Q138 219 132 186T125 128Q125 81 146 54T209 26T302 45T394 111Q403 121 406 121Q410 121 419 112T429 98T420 82T390 55T344 24T281 -1T205 -11Q126 -11 83 42T39 168ZM373 353Q367 405 305 405Q272 405 244 391T199 357T170 316T154 280T149 261Q149 260 169 260Q282 260 327 284T373 353Z"></path><path stroke-width="0" id="E1-MJMATHI-64" d="M366 683Q367 683 438 688T511 694Q523 694 523 686Q523 679 450 384T375 83T374 68Q374 26 402 26Q411 27 422 35Q443 55 463 131Q469 151 473 152Q475 153 483 153H487H491Q506 153 506 145Q506 140 503 129Q490 79 473 48T445 8T417 -8Q409 -10 393 -10Q359 -10 336 5T306 36L300 51Q299 52 296 50Q294 48 292 46Q233 -10 172 -10Q117 -10 75 30T33 157Q33 205 53 255T101 341Q148 398 195 420T280 442Q336 442 364 400Q369 394 369 396Q370 400 396 505T424 616Q424 629 417 632T378 637H357Q351 643 351 645T353 664Q358 683 366 683ZM352 326Q329 405 277 405Q242 405 210 374T160 293Q131 214 119 129Q119 126 119 118T118 106Q118 61 136 44T179 26Q233 26 290 98L298 109L352 326Z"></path><path stroke-width="0" id="E1-MJMATHI-69" d="M184 600Q184 624 203 642T247 661Q265 661 277 649T290 619Q290 596 270 577T226 557Q211 557 198 567T184 600ZM21 287Q21 295 30 318T54 369T98 420T158 442Q197 442 223 419T250 357Q250 340 236 301T196 196T154 83Q149 61 149 51Q149 26 166 26Q175 26 185 29T208 43T235 78T260 137Q263 149 265 151T282 153Q302 153 302 143Q302 135 293 112T268 61T223 11T161 -11Q129 -11 102 10T74 74Q74 91 79 106T122 220Q160 321 166 341T173 380Q173 404 156 404H154Q124 404 99 371T61 287Q60 286 59 284T58 281T56 279T53 278T49 278T41 278H27Q21 284 21 287Z"></path><path stroke-width="0" id="E1-MJMATHI-63" d="M34 159Q34 268 120 355T306 442Q362 442 394 418T427 355Q427 326 408 306T360 285Q341 285 330 295T319 325T330 359T352 380T366 386H367Q367 388 361 392T340 400T306 404Q276 404 249 390Q228 381 206 359Q162 315 142 235T121 119Q121 73 147 50Q169 26 205 26H209Q321 26 394 111Q403 121 406 121Q410 121 419 112T429 98T420 83T391 55T346 25T282 0T202 -11Q127 -11 81 37T34 159Z"></path><path stroke-width="0" id="E1-MJMATHI-74" d="M26 385Q19 392 19 395Q19 399 22 411T27 425Q29 430 36 430T87 431H140L159 511Q162 522 166 540T173 566T179 586T187 603T197 615T211 624T229 626Q247 625 254 615T261 596Q261 589 252 549T232 470L222 433Q222 431 272 431H323Q330 424 330 420Q330 398 317 385H210L174 240Q135 80 135 68Q135 26 162 26Q197 26 230 60T283 144Q285 150 288 151T303 153H307Q322 153 322 145Q322 142 319 133Q314 117 301 95T267 48T216 6T155 -11Q125 -11 98 4T59 56Q57 64 57 83V101L92 241Q127 382 128 383Q128 385 77 385H26Z"></path><path stroke-width="0" id="E1-MJMATHI-6E" d="M21 287Q22 293 24 303T36 341T56 388T89 425T135 442Q171 442 195 424T225 390T231 369Q231 367 232 367L243 378Q304 442 382 442Q436 442 469 415T503 336T465 179T427 52Q427 26 444 26Q450 26 453 27Q482 32 505 65T540 145Q542 153 560 153Q580 153 580 145Q580 144 576 130Q568 101 554 73T508 17T439 -10Q392 -10 371 17T350 73Q350 92 386 193T423 345Q423 404 379 404H374Q288 404 229 303L222 291L189 157Q156 26 151 16Q138 -11 108 -11Q95 -11 87 -5T76 7T74 17Q74 30 112 180T152 343Q153 348 153 366Q153 405 129 405Q91 405 66 305Q60 285 60 284Q58 278 41 278H27Q21 284 21 287Z"></path></defs><g stroke="currentColor" fill="currentColor" stroke-width="0" transform="matrix(1 0 0 -1 0 0)"><use xlink:href="#E1-MJMATHI-4C" x="0" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-32" x="963" y="-213"></use><use xlink:href="#E1-MJMATHI-4C" x="1134" y="0"></use><use xlink:href="#E1-MJMATHI-6F" x="1815" y="0"></use><use xlink:href="#E1-MJMATHI-73" x="2300" y="0"></use><use xlink:href="#E1-MJMATHI-73" x="2769" y="0"></use><use xlink:href="#E1-MJMAIN-3D" x="3516" y="0"></use><g transform="translate(4572,0)"><use xlink:href="#E1-MJSZ2-2211" x="557" y="0"></use><g transform="translate(0,-1147)"><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-28" x="0" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMATHI-78" x="389" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-2C" x="961" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMATHI-79" x="1239" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-29" x="1735" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-2208" x="2125" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMATHI-44" x="2792" y="0"></use></g></g><use xlink:href="#E1-MJMAIN-28" x="7131" y="0"></use><use xlink:href="#E1-MJMATHI-79" x="7520" y="0"></use><use xlink:href="#E1-MJMAIN-2212" x="8240" y="0"></use><use xlink:href="#E1-MJMATHI-70" x="9240" y="0"></use><use xlink:href="#E1-MJMATHI-72" x="9743" y="0"></use><use xlink:href="#E1-MJMATHI-65" x="10194" y="0"></use><use xlink:href="#E1-MJMATHI-64" x="10660" y="0"></use><use xlink:href="#E1-MJMATHI-69" x="11183" y="0"></use><use xlink:href="#E1-MJMATHI-63" x="11528" y="0"></use><use xlink:href="#E1-MJMATHI-74" x="11961" y="0"></use><use xlink:href="#E1-MJMATHI-69" x="12322" y="0"></use><use xlink:href="#E1-MJMATHI-6F" x="12667" y="0"></use><use xlink:href="#E1-MJMATHI-6E" x="13152" y="0"></use><use xlink:href="#E1-MJMAIN-28" x="13752" y="0"></use><use xlink:href="#E1-MJMATHI-78" x="14141" y="0"></use><use xlink:href="#E1-MJMAIN-29" x="14713" y="0"></use><g transform="translate(15102,0)"><use xlink:href="#E1-MJMAIN-29" x="0" y="0"></use><use transform="scale(0.707)" xlink:href="#E1-MJMAIN-32" x="550" y="583"></use></g></g></svg></span></div><script type="math/tex; mode=display" id="MathJax-Element-1">L_2Loss=\sum_{(x,y)\in D}(y-prediction(x))^2</script></div></div>
                    <p>&nbsp;</p>
                    </li>

                    </ul>
                    <ul>
                    <li>D is something we are dividing all values by <code>||D||</code></li>

                    </ul>
                    </li>

                    </ul>
                    <h2>Key Terms</h2>
                    <ul>
                    <li><strong>bias</strong>: An intercept or offset from an origin same as y intercept</li>
                    <li><strong>linear regression</strong>: A model that predicts the raw outputs</li>
                    <li><strong>inference</strong>: Making prediction through unlabeled examples</li>
                    <li><strong>weight</strong>: A coefficient for a feature, the slope</li>

                    </ul>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-10-12">
                  <div class="page-content centre"> 
                    <h1>2019-10-12</h1><hr>
                    <p>Today I meet with Mr. Stiefel to ask some questions I had about machine learning. I had just made it through the lecture and steps about reducing loss and I was interested in learning at a more complex level - the calculus behind machine learning. Mr. Stiefel showed me the basic derivative rules as a basis for understanding how derivatives may be manipulated.</p>
                    <p>In the machine learning crash course they were using derivatives, partial derivatives, and matrices of partial derivatives to determine in which direction the program needs to step in order to reduce loss. Thus the chapter&#39;s name: reducing loss.</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-10-26">
                  <div class="page-content centre"> 
                    <h1>2019-10-26</h1>
                    <p>Today I took my &quot;first steps with tensorflow&quot;. I built my first machine learning algorithm using all of the knowledge that I have acquired up to this point. The program itself is pretty simple so I&#39;ll just run through the code. It&#39;s under Housing Prices on the website. For the math/ machine learning part I import math, numpy, pandas, and tensorflow. For display I import matplot and IPython. The first few lines of code just set logging verbosity and general formating. Then I import my data as a dataframe - think of it sort of like a spreadsheet from excel - it simply includes a bunch of information about housing prices in california. Then I randomize the order of the data in the dataframe to prevent any bias due to order. I then formated my response variable - median house value - in units of 1000. I then have the program print a simple description of the data. Then I create a function that inputs and formats the data for machine learning goodness. The next function just trains the model and takes learning_rate, steps, batch_size, and input_feature as variables - this is from the previous lessons. I have the data train tenths so I have easy places to check on the data. The last few lines of code setup the graph output and the command line output. Finally the functions are called and the data is trained on. </p>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-11-02">
                  <div class="page-content centre"> 
                    <h1>2019-11-02</h1>
                    <p>Today I did some more research for my personal project. I was able to meet with Dr. Kuchera at Davidson College and learn more about computational physics - a common application for machine learning. I learned about some higher-level machine learning like Generative Adversarial Networking or GAN. It can be used to predict output images and clean up input images. Unsupervised learning can be used to predict Monte Carlo events. The most interesting thing has got to be TensorBNN a custom library that allows for Bayesian calculations using machine learning - a previously unbreached field. </p>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-11-09">
                  <div class="page-content centre"> 
                    <h1>Generalization</h1><hr>
                    <ul>
                    <li>Machine learning separates itself from statistics because data can be generalized, without generalization we would just be doing regression models
                    </li>
                    <li>Some people incorrectly try to make models better by making really complex lines with the training data - this is known as <strong>overfitting</strong>
                    </li>
                    <li>The issue is if new examples are added and the model won&#39;t be able to sort them.
                    </li>
                    <li>To improve generalization one process is used, the Ockham of Ockham's Razor developed generalization theory 
                    </li>
                    <li>Theory is fine - but how do we do anything - it's pretty simple again, just train on part of the labeled data then practice on labeled data and you know how good your model is given any random dataset. This relies on three premises:
                    <ul>
                    <li>Draw examples randomly</li>
                    <li>The <strong>population</strong> is stable</li>
                    <li>Always pull from the same data.</li>

                    </ul>
                    </li>

                    </ul>
                    <p><img src="assets/general.png" referrerpolicy="no-referrer" alt="Screenshot from 2020-01-29 22-13-12"></p>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-11-16">
                  <div class="page-content centre"> 
                    <h1>Training and Test Sets</h1><hr>
                    <ul>
                    <li>This expands the ideas of generalization</li>
                    <li>If you can only do one sample from your population you want to take a SRS of the draw to split into a training set and a test.</li>
                    <li>The balance between the two sets is really difficult with only one draw - the larger the training data the better the model, the larger the test set the larger the confidence intervals.</li>
                    <li>Cross-validation can be used to account for only have one draw.</li>
                    <li><strong>Never</strong> train on test data, it will seriously mess up your model.</li>

                    </ul>
                    <h3>Low Amount of Training Data</h3><img src="assets/train1.png" referrerpolicy="no-referrer" alt="Screenshot from 2020-01-29 22-28-48">
                    <h3>50-50 Split</h3>
                    <p><img src="assets/train2.png" referrerpolicy="no-referrer" alt="Screenshot from 2020-01-29 22-30-34"></p>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-11-23">
                  <div class="page-content centre"> 
                    <h1>Validation</h1><hr>
                    <ul>
                    <li>As discussed in my previous 2 journal entries, over fit is the bane of any good model and we must avoid it because without over fit we simply have a regression that can&#39;t be extrapolated to the rest of my data.</li>
                    <li>Using the &quot;test set&quot; and &quot;training set&quot; model is a good idea - but it introduces 1 key problem, you can still over fit - simply just to the 2 datasets you&#39;re looking at - especially if you&#39;re using a genetic model which does many, many iterations which will very often cause a model that has no larger generalization. This is why we further split our &quot;test set&quot; into a &quot;test set&quot; and &quot;validation set&quot;. You train your model on the &quot;training&quot; and &quot;validation&quot; sets and then to reduce exposure you only verify once or twice on the test set.</li>
                    <li>This is what my latest iteration of the gradient descent model does - it introduces the concept of validation into the code.</li>

                    </ul>
                    <p><img src="assets/PartitionThreeSets.svg" referrerpolicy="no-referrer" alt="A horizontal bar divided into three pieces: 70% of which is the training set, 15% the validation set, and 15% the test set"></p>
                    <p>&nbsp;</p>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-11-30">
                  <div class="page-content centre"> 
                    <h1>Representation</h1><hr>
                    <ul>
                    <li>When data is given in the real world it is rarely actually sorted or formated properly</p>
                    </li>
                    <li>Creating features or explanatory variables is called feature engineering</p>
                    </li>
                    <li>Things that are numerical like a number of rooms are easy</p>
                    </li>
                    <li>The hard thing is a categorical variable like a string or text, like the street the house is on, there are several stratagems here</p>
                    <ul>
                    <li>One-Hot Encoding: If you only care about one value, give that value a value of <code>1</code> and everything else <code>0</code></li>

                    </ul>
                    </li>
                    <li>A feature should occur pretty often</p>
                    </li>
                    <li>Features should be clear and obvious, makes optimization much easier</p>
                    </li>
                    <li>No magic values, like putting a <code>-1</code> for houses that have never been on the market, this will mess up models</p>
                    </li>
                    <li>The definition of a feature shouldn&#39;t change over time, the data should always be in the same units</p>
                    </li>
                    <li>Data should not have outliers, since much of this is simply regression+, an outlier will hurt the model</p>
                    </li>
                    <li>You can bin data - separate data into certain categories and then use those separated bins to make predictions. For instance you could bin the entire US by city and then see if the east side of cities is more wealthy than the west side.</p>
                    </li>
                    <li>Visualize the data before you use it. Plot histograms and the like</p>
                    </li>
                    <li>Debug the data to view any duplicates, outliers, and the like</p>
                    </li>
                    <li>Look at the descriptive statistics of the data over time - especially if you&#39;re adding data.</p>
                    </li>
                    <li>I&#39;m now going to implement the concepts into the model which has now been semi-generalized.</p>
                    </li>

                    </ul>
                    <p>&nbsp;</p>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-12-07">
                  <div class="page-content centre"> 
                    <h1>Feature Crosses</h1><hr>
                    <ul>
                    <li>This is the art of creating synthetic features, something I&#39;ve been doing for a while, but really need to fully understand.</li>
                    <li>They are really helpful for fitting non-linear methods to gradient descent</li>
                    <li>They may be very sparse if you cross one-hot features which could be bad for your model</li>
                    <li>I&#39;m going to implement them into my housing model</li>

                    </ul>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-12-14">
                  <div class="page-content centre"> 
                    <h1>Regularization</h1><hr>
                    <ul>
                    <li>Regularization is the science penalizing the complexity of a model to reduce over fitting as creating super specific synthetic features can be dangerous for a model.</li>
                    <li>Often as training loss goes down, validation loss goes up due to over fitting</li>
                    <li>One strategy is just to stop training your model to prevent over fit</li>
                    <li>The other main paradigm is penalizing complexity in the model</li>
                    <li>You can prefer smaller weights so that one var is weighed to much</li>
                    <li>The main way to penalize weight inflation is through L<sub>2</sub> or ridge regularization</li>

                    </ul>
                    <h2>How Does It Work</h2>
                    <ul>
                    <li>It takes the sum of the squares of the weights</li>
                    <li>It uses a Bayesian prior - like a density graph (centered on 0, normal distribution)</li>
                    <li>Balance reducing loss vs generalization through λ which controls the weight of the two.</li>
                    <li>With lots of training data you should not use to much regularization</li>
                    <li>With little or novel training data use as many regularization methods as needed</li>

                    </ul>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-12-21">
                  <div class="page-content centre"> 
                    <h1>Logistic Regression</h1><hr>
                    <ul>
                    <li>Logistic regression is a strategy for models where you create long run probabilities rather than direct categories.</li>
                    <li>For example a linear model of coin flips with abnormal coins - you could build a model for angle of bend and coin mass as features.</li>
                    <li>This model of regression can often create probabilities outside of 0 -1 which is impossible. You must often create a new model - a logistic model to create probabilities rather than straight categories. This is helpful for spam or not spam email categorization.</li>
                    <li>The first step is to put the model into a sigmoid model which will cap probabilities at 0 and 1 - this function&#39;s asymptotes. Sigmoid is represented by the function y<sup>&#39;</sup> = 1/1 + e<sup>-(x)</sup></li>
                    <li>x = b+w<sub>1</sub> x<sub>1</sub> + w<sub>2</sub> x<sub>2</sub> +... + regularization</li>
                    <li>x = log(y/1-y)</li>
                    <li>To use a loss model you should use log loss rather than traditional squared loss. The loss gets very high as you approach 0 or 1 to prevent impossible probabilities</li>
                    <li>Over fit is a real danger here as these models - so regularization will be key.</li>
                    <li>Linear Logistic Regression is very fast and gives very fast prediction times a well. Crossing allows non-linear methodology</li>

                    </ul>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-12-28">
                  <div class="page-content centre"> 
                    <h1>Regularization for Sparsity</h1><hr>
                    <ul>
                    <li>I want look more at feature crosses. Since I&#39;ve converted my algorithm to classification it makes sense to look at regularization and feature crosses again. Especially feature crosses when both features are sparse.</li>
                    <li>This causes two issues: RAM Usage (the model becomes massive) and a lot of &quot;Noise&quot; in the model causing over fitting. We need to regularize in a way to zero out weights and reduce model size.</li>
                    <li>We should penalize the the number of weights by penalizing the sum of the absolute value of weights.</li>

                    </ul>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2020-01-04">
                  <div class="page-content centre"> 
                    <h1>Introduction to Neural Networks</h1><hr>
                    <ul>
                    <li>For the entirety of the this project I have only done linear/ gradient descent work - however much of machine learning - especially that which isn&#39;t as simple as a prediction needs a more complex model or a neural network.</li>

                    </ul>
                    <p><img src="assets/NonLinearSpiral.png" referrerpolicy="no-referrer"></p>
                    <ul>
                    <li>The above image is an excellent example of when we must begin using neural networks - trying to use simple feature crossing and other &quot;tricks&quot; to get non-linear data to fit to a linear model will no longer work. I want a way for the model to figure out the non-linear data without me having to sit around and figure out which advanced functions fit to the data - which would kill generalization.</li>
                    <li>Neural networks are made to deal with this in particular. They are really good at data that is more soft, and would have many, many, many features like music, writing, photos - essentially anything a human could create and sort.</li>
                    <li>A linear model is pretty simple - a set amount of inputs weighted linearly and maybe run through a function like sigmoid to produce an output. The hidden layer represents any clever math that had to be done to the non-linear data. We can keep on adding hidden layers - but  the model will stay linear.</li>

                    </ul>
                    <p><img src="assets/linear_net.svg" referrerpolicy="no-referrer"></p>
                    <p><img src="assets/1hidden.svg" referrerpolicy="no-referrer"></p>
                    <ul>
                    <li>The best way to fix is to break the linear pattern somewhere along the model through an activation functions. There a bunch of ways to convert from non linear to linear like <code>RELU</code> or <code>Sigmoid</code> or <code>tanh</code>. You train neural networks through a method called backpropagation. Where gradient descent simply used derivatives to move along a curve of the weights vs loss, backpropagation uses the loss function and finds the gradient between each layer with respect to the layer&#39;s weights, this process proceeds backwards through the model allows partial calculations to be used for computation in each layer.</li>

                    </ul>
                    <p><img src="assets/activation.svg" referrerpolicy="no-referrer"></p>
                    <ul>
                    <li>I am now going to convert to housing model into a neural network</li>

                    </ul>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-01-11">
                  <div class="page-content centre"> 
                    <h1>Training Neural Networks</h1><hr>
                    <ul>
                    <li>Training neural network is done through a process called backpropagation which I don&#39;t understand on a really deep level.</li>
                    <li>Traditional forward propagation works through a simple sigma function that changes the weights of the output to compute the input of the next layer until error is reduced. This is really computationally intensive</li>
                    <li>Backpropagation works backwards by changing each  weight in the network after comparing th predicted output with the desired output for that node. To do that you use dE/dw<sub>ij</sub> which computes how error changes in respect to a weight. Using the error derivatives you can use an update rule to change the weights.</li>
                    <li>Tensorflow luckily does the calculus for you. Backpropagation relies on gradients and differentiable functions. Near the input the gradients can become so small that learning no longer happens, however <code>ReLU</code> can fix this.</li>
                    <li>Be careful doing <code>ReLU</code> because if the weighted sum falls below 0 then the <code>ReLU</code> will drop everything causing 0 activation.</li>
                    <li>With high learning rate it can result in a NaN because of exploding gradients. The weights combined with how the update rule works causes many issues. However, batch normalization can help.</li>
                    <li>You should normalize the feature values so that the neural network has to do less work. </li>
                    <li>You can also use dropout regularization which drops out random nodes or units within single gradient steps.</li>

                    </ul>
                    <p>&nbsp;</p>
                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-01-18">
                  <div class="page-content centre"> 
                    <h1>Handwritten Digit Multi-Class Neural Network</h1><hr>
                    <ul>
                    <li>I need to build a classification model for one of my 2 &quot;cumulative&quot; that allows me to classify multiple things and for that you must use a multi-class neural network - linear models work for binary-class problems.</li>
                    <li>The paradigm here is a one vs all classification. You want to create a unique output node for every class and then use a DNN or separate models to train each class in one vs all. In a DNN you can share all of the internals. You should use softmax that requires the output all one vs all to sum to 1 to make sure there is proper single-label multi-class classification as logistic regression is happening which gives probabilities. Examples may only be a member of one class and using softmax insures this. You need to encode into the loss.</li>

                    </ul>
                    <p><img src="assets/OneVsAll.svg" referrerpolicy="no-referrer"></p>
                    <ul>
                    <li>For multi-class multi-labeln classification there needs to be no constraints on class membership.</li>
                    <li>Full SoftMax: Just brute forces all of the output nodes and trains them one by one.</li>
                    <li>Candidate Sampling: If the output node is very sparse you can take a SRS of the negatives and only train on them for instance if you were identifying dogs but had just general photos being read into the model you just need to take a SRS of the others, so you may just train on the dogs and then a toaster, calculator, and human.</li>

                    </ul>
                    <p>&nbsp;</p>

                  </div>
                </section>
                <section class="mdl-layout__tab-panel is-active" id="2019-01-25">
                  <div class="page-content centre"> 
                    <h1>Reviews via Embeddings</h1><hr>
                    <ul>
                    <li>If you want to make movie recommendations based on what movies users have watched you need to find the similarity.</li>
                    <li>An embedding in 1d would be sorting the movies by whether they&#39;re animated or not. Only using 1d could be disastrous as you could recommend a movie like Sausage Party to kids simply because it&#39;s animated. You could try adding a 2nd dimension. You can continue adding dimensions until the model is good. The network will just give a Cartesian coordinate to each movie to allow dimensions to be understood by the model. All of this assumes that your features actually have any predictive power. </li>
                    <li>An embedding can actually be really similar because the embedding will just be a hidden layer with one node per dimension - supervised information like users watching the same two movies allows weights to be added to the nodes. </li>
                    <li>Since the matrix will be very sparse you only want to note the movies that have been watched. You just map a slice or dictionary to the movie and then you can associate a list which each user without having the note all of the movies the user did not watch.</li>

                    </ul>
                    <p><img src="assets/InputRepresentationWithValues.png"></p>
                    <ul>
                    <li>You can even do this for the housing problem. You could create an embedding on the words within a real estate ad to understand how expensive or cheap houses group. You can add the rest of the features as normal inputs.</li>
                    <li>I could even do this for the hand written digit and do an embedding on what area on digit is colored in - the embedding much like the multi-class neural network can give a probability distribution just based on the similarities.</li>
                    <li>For the movie recommendation you use the movies that were watched as labels sorted through the embedding, and then create an embedding and maybe a multi-class neural network for the other movies.</li>

                    </ul>
                    <p><img src="assets/EmbeddingExample3-1.svg" referrerpolicy="no-referrer"></p>
                    <ul>
                    <li>You can even weight each dimension in an embedding to increase or decrease the power of each dimension.</li>
                    <li>More dimensions can be dangerous because it can create over fit and slower training. I will generally optimize my number of dimensions to be equal to the fourth root of the possible values.</li>
                    <li>I find embeddings really cool because it creates a lot of structure in the generally unstructured supervised learning that I have been doing up to now.</li>

                    </ul>
                    <p><img src="assets/linear-relationships.svg" referrerpolicy="no-referrer" alt="), verb tense (walking/walked and swimming/swam), and capital cities (Turkey/Ankara and Vietnam/Hanoi)"></p>
                  </div>
                </section>
                <button onclick="location.href='';" class="mdl-button mdl-js-button mdl-button--fab mdl-button--mini-fab button-accent floating">
                  <i class="material-icons">replay</i>
                </button>  
            </main>
          </div>
    </body>
    
</html>